# BaseDataQuery

class `openff.evaluator.storage.query.``BaseDataQuery`

  A base class for queries which can be made to a StorageBackend.

  `__init__`()

    Initialize self. See help(type(self)) for accurate signature.

  Methods

  `__init__` | Initialize self.
  `apply`(data_object) | Apply this query to a data object.
  `data_class`() | The type of data class that this query can be applied to.
  `from_data_object`(data_object) | Returns the query which would match this data object.
  `from_json`(file_path) | Create this object from a JSON file.
  `get_attributes`([attribute_type]) | Returns all attributes of a specific attribute_type.
  `json`([file_path, format]) | Creates a JSON representation of this class.
  `parse_json`(string_contents[, encoding]) | Parses a typed json string into the corresponding class structure.
  `validate`([attribute_type]) | Validate the values of the attributes.

  abstract classmethod `data_class`()

    The type of data class that this query can be applied to.

    Returns

    Return type

      type of BaseStoredData

  `apply`(data_object)

    Apply this query to a data object.

    Parameters

      data_object (BaseStoredData) – The data object to apply the query to.

    Returns

      The values of the matched parameters of the data object fully matched this query, otherwise None.

    Return type

      tuple of Any, optional

  classmethod `from_data_object`(data_object)

    Returns the query which would match this data object.

    Parameters

      data_object (BaseStoredData) – The data object to construct the query for.

    Returns

      The query which would match this data object.

    Return type

      cls

  classmethod `from_json`(file_path)

    Create this object from a JSON file.

    Parameters

      file_path (str) – The path to load the JSON from.

    Returns

      The parsed class.

    Return type

      cls

  classmethod `get_attributes`(attribute_type=None)

    Returns all attributes of a specific attribute_type.

    Parameters

      attribute_type (type of Attribute, optional) – The type of attribute to search for.

    Returns

      The names of the attributes of the specified type.

    Return type

      list of str

  `json`(file_path=None, format=False)

    Creates a JSON representation of this class.

    Parameters

      - file_path (str, optional) – The (optional) file path to save the JSON file to.

      - format (bool) – Whether to format the JSON or not.

    Returns

      The JSON representation of this class.

    Return type

      str

  classmethod `parse_json`(string_contents, encoding='utf8')

    Parses a typed json string into the corresponding class structure.

    Parameters

      - string_contents (str or bytes) – The typed json string.

      - encoding (str) – The encoding of the string_contents.

    Returns

      The parsed class.

    Return type

      Any

  `validate`(attribute_type=None)

    Validate the values of the attributes. If attribute_type is set, only attributes of that type will be validated.

    Parameters

      attribute_type (type of Attribute, optional) – The type of attribute to validate.

    Raises

      ValueError or AssertionError –